#########
# Author:        ajb
# Maintainer:    $Author: ajb $
# Created:       2008-06-10
# Last Modified: $Date: 2008-07-22 12:49:49 +0100 (Tue, 22 Jul 2008) $
# Id:            $Id: process.pm 2441 2008-07-22 11:49:49Z ajb $
# Source:        $Source: /repos/cvs/webcore/SHARED_docs/cgi-bin/docrep,v $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-2.0/lib/npg_qc/api/process.pm $
#

package npg_qc::api::process;
use strict;
use warnings;
use Class::Std;
use base qw(npg_qc::api::base);
use Perl6::Slurp;
use Readonly;

our $VERSION = do { my ($r) = q$LastChangedRevision: 2441 $ =~ /(\d+)/mx; $r; };
{
  ## no critic
  my %id_run_of   :ATTR( :get<id_run>,   :set<id_run> );
  ## use critic

  sub read_file {
    my ($self, $file_url) = @_;
    return slurp $file_url;
  }

  sub process_id_run {
    my ($self, $file_url) = @_;
    my $capture;
    ($capture) = $file_url =~ /Data/xms           ? $file_url =~ /_0*(\d+)\/Data/xms
               : $file_url =~ /Latest_Summary/xms ? $file_url =~ /_0*(\d+)\/Latest_Summary/xms
               : $file_url =~ /RunLog_concat/xms  ? $file_url =~ /_0*(\d+)\/RunLog_concat/xms
               :                                    undef
               ;
    $self->set_id_run($capture);
    return 1;
  }
}
1;
__END__

=head1 NAME

npg_qc::api::process

=head1 VERSION

$LastChangedRevision: 2441 $

=head1 SYNOPSIS

=head1 DESCRIPTION

Base class for npg_qc::api::process::Derived class objects

=head1 SUBROUTINES/METHODS

=head2 read_file - slurps in given file at $full_path_uri_for_file and returns as a string

  my $sFileContents = $o<Derived>->read_file($full_path_uri_for_file);

=head2 process_id_run - takes a url of a file and determines the id_run from it, which it then sets

  $o<Derived>->process_id_run($full_path_uri_for_file);

=head1 DIAGNOSTICS

=head1 CONFIGURATION AND ENVIRONMENT

=head1 DEPENDENCIES

strict
warnings
Class::Std
npg_qc::api::base
Perl6::Slurp

=head1 INCOMPATIBILITIES

=head1 BUGS AND LIMITATIONS

=head1 AUTHOR

Andy Brown, E<lt>ajb@sanger.ac.ukE<gt>

=head1 LICENSE AND COPYRIGHT

Copyright (C) 2008 GRL, by Andy Brown

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.8.4 or,
at your option, any later version of Perl 5 you may have available.

=cut
