#########
# Author:        ajb
# Maintainer:    $Author: ajb $
# Created:       2008-06-10
# Last Modified: $Date: 2008-07-22 09:05:37 +0100 (Tue, 22 Jul 2008) $
# Id:            $Id: error_rate_relative_reference_cycle_nucleotide.pm 2430 2008-07-22 08:05:37Z ajb $
# Source:        $Source: /repos/cvs/webcore/SHARED_docs/cgi-bin/docrep,v $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-2.0/lib/npg_qc/model/error_rate_relative_reference_cycle_nucleotide.pm $
#

package npg_qc::model::error_rate_relative_reference_cycle_nucleotide;
use strict;
use warnings;
use base qw(npg_qc::model);

our $VERSION = do { my ($r) = q$LastChangedRevision: 2430 $ =~ /(\d+)/mx; $r; };

__PACKAGE__->mk_accessors(__PACKAGE__->fields());

sub fields {
  return qw(
            id_error_rate_relative_reference_cycle_nucleotide
            id_run_tile
            cycle
            read_as
            really_a
            really_c
            really_g
            really_t
            rescore
          );
}

sub run_tile {
  my $self  = shift;
  my $pkg   = 'npg_qc::model::run_tile';
  return $pkg->new({
		    'util' => $self->util(),
		    'id_run_tile' => $self->id_run_tile(),
		   });
}

1;
__END__
=head1 NAME

npg_qc::model::error_rate_relative_reference_cycle_nucleotide

=head1 VERSION

$LastChangedRevision: 2430 $

=head1 SYNOPSIS

  my $oErrorRateRelativeReferenceCycleNucleotide = npg_qc::model::error_rate_relative_reference_cycle_nucleotide->new({util => $util});

=head1 DESCRIPTION

=head1 SUBROUTINES/METHODS

=head2 fields - return array of fields, first of which is the primary key

  my $aFields = $oErrorRateRelativeReferenceCycleNucleotide->fields();

=head2 run_tile - returns run_tile object that this object belongs to

  my $oRunTile = $oErrorRateRelativeReferenceCycleNucleotide->run_tile();

=head1 DIAGNOSTICS

=head1 CONFIGURATION AND ENVIRONMENT

=head1 DEPENDENCIES

strict
warnings
npg_qc::model

=head1 INCOMPATIBILITIES

=head1 BUGS AND LIMITATIONS

=head1 AUTHOR

Andy Brown, E<lt>ajb@sanger.ac.ukE<gt>

=head1 LICENSE AND COPYRIGHT

Copyright (C) 2008 GRL, by Andy Brown

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.8.4 or,
at your option, any later version of Perl 5 you may have available.

=cut
