#########
# Author:        ajb
# Maintainer:    $Author: gq1 $
# Created:       2008-09-25
# Last Modified: $Date: 2008-10-10 09:45:46 +0100 (Fri, 10 Oct 2008) $
# Id:            $Id: run_log.pm 3210 2008-10-10 08:45:46Z gq1 $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-2.0/lib/npg_qc/model/run_log.pm $
#

package npg_qc::model::run_log;
use strict;
use warnings;
use base qw(npg_qc::model);
use Carp;
use English qw(-no_match_vars);
use Statistics::Lite qw(:all);
use Readonly;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3210 $ =~ /(\d+)/mx; $r; };

__PACKAGE__->mk_accessors(fields());

sub fields {
  return qw(id_run);
}

sub metrics {
  my ($self) = @_;
  return [
    { module => 'move_z', title => 'Move Z Information', }
  ];
}


1;
__END__
=head1 NAME

npg_qc::model::run_log

=head1 VERSION

$LastChangedRevision: 3210 $

=head1 SYNOPSIS

  my $oRunLog = npg_qc::model::run_log->new({util => $util});

=head1 DESCRIPTION

Base model to sit under npg_qc::view::run_log

=head1 SUBROUTINES/METHODS

=head2 fields - returns list of fields to be populated as accessors

=head2 metrics - returns an arrayref containing hashes of the different run_log metrics available, for use in constructing links

  my $aMetrics = $oRunLog->metrics();

=head1 DIAGNOSTICS

=head1 CONFIGURATION AND ENVIRONMENT

=head1 DEPENDENCIES

strict
warnings
npg_qc::model
English
Carp
Statistics::Lite
Readonly

=head1 INCOMPATIBILITIES

=head1 BUGS AND LIMITATIONS

=head1 AUTHOR

Andy Brown, E<lt>ajb@sanger.ac.ukE<gt>

=head1 LICENSE AND COPYRIGHT

Copyright (C) 2008 GRL, by Andy Brown

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.8.4 or,
at your option, any later version of Perl 5 you may have available.

=cut
