#########
# Author:        ajb
# Maintainer:    $Author: ajb $
# Created:       2008-06-10
# Last Modified: $Date: 2008-10-10 12:30:27 +0100 (Fri, 10 Oct 2008) $
# Id:            $Id: run_tile.pm 3216 2008-10-10 11:30:27Z ajb $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-2.0/lib/npg_qc/view/run_tile.pm $
#

package npg_qc::view::run_tile;
use strict;
use warnings;
use base qw(npg_qc::view);
use Carp;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3216 $ =~ /(\d+)/mx; $r; };

sub decor {
  my ($self, @args) = @_;
  
  my $aspect = $self->aspect() || q();

  if($aspect eq 'read_tile_viewer') {
    return 0;
  }

  return $self->SUPER::decor(@args);
}

sub read_tile_viewer {
  my ($self) = @_;
  my $model  = $self->model();
  my $cgi    = $self->util->cgi();
  
  $model->{tile_viewer} = 1;
  $model->{id_run_tile} = $cgi->param('id_run_tile');
  $model->{id_run}      = $cgi->param('id_run');
  $model->{position}    = $cgi->param('position');
  $model->{tile}        = $cgi->param('tile');
  $model->{end}         = $cgi->param('end') || 1;
  $model->{cycle}       = $cgi->param('cycle') || 1;
  $model->read();
  $model->{source}      = $cgi->param('source');
#croak "$model->{id_run_tile}:$model->{id_run}:$model->{position}";
  $model->{previous} = $model->{cycle} - 1;
  $model->{next}     = $model->{cycle} + 1;

  return;
}
sub list_movez_id_run_xml{
  my ($self) = @_;
  return;
}

1;
__END__
=head1 NAME

npg_qc::view::run_tile

=head1 VERSION

$LastChangedRevision: 3216 $

=head1 SYNOPSIS

  my $o = npg_qc::view::run_tile->new({util => $util});

=head1 DESCRIPTION

=head1 SUBROUTINES/METHODS

=head2 decor - handler to render no decor if read_tile_viewer selected

=head2 read_tile_viewer - handler to render the pop-up tile viewer

=head2 list_movez_id_run_xml - handler to return the list id_runs with movez data already in the database

=head1 DIAGNOSTICS

=head1 CONFIGURATION AND ENVIRONMENT

=head1 DEPENDENCIES

strict
warnings
npg_qc::view

=head1 INCOMPATIBILITIES

=head1 BUGS AND LIMITATIONS

=head1 AUTHOR

Andy Brown, E<lt>ajb@sanger.ac.ukE<gt>

=head1 LICENSE AND COPYRIGHT

Copyright (C) 2008 GRL, by Andy Brown

This library is free software; you can redistribute it and/or modify
it under the same terms as Perl itself, either Perl version 5.8.4 or,
at your option, any later version of Perl 5 you may have available.

=cut
