#!/nfs/team117/gq1/dev/bin/perl -wT
##!/software/bin/perl -wT
#########
# Author:        gq1
# Maintainer:    $Author: gq1 $
# Created:       2008-09-30
# Last Modified: $Date: 2008-10-10 09:45:46 +0100 (Fri, 10 Oct 2008) $
# Id:            $Id: npg_qc_api_run_graph.pl 3210 2008-10-10 08:45:46Z gq1 $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-2.0/scripts/npg_qc_api_run_graph.pl $
#

use strict;
use warnings;
use lib qw(lib /software/solexa/lib/site_perl/);
use SangerPaths qw(core ensembl tracking trackingnpg badger);
use npg_qc::api::run_caching;
use npg_qc::api::util;
use LWP::UserAgent;
use Carp;
use English qw{-no_match_vars};
use Getopt::Long;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3210 $ =~ /(\d+)/mx; $r; };

$ENV{'PATH'} = join q(:), qw(/bin /usr/bin /usr/local/bin);

main();
0;

sub main {
  print qq{Processing...\n};
  
  my $opts = initialise();

  #########
  # overide base uri for npg_qc
  my $uri  = q{http://deskpro19635.dynamic.sanger.ac.uk:8080/cgi-bin/prodsoft/npg_qc/npg_qc/};
  #my $uri  = q{http://intwebdev.sanger.ac.uk/cgi-bin/prodsoft/npg_qc/npg_qc/};

  my $util = npg_qc::api::util->new({
    useragent => undef,
    base_uri  => $uri,
    parser    => undef,
  });

  my $api_run_caching = npg_qc::api::run_caching->new({
                                       util => $util,
                                       });  
  eval{
    if($opts->{id_run}){ 
      $api_run_caching->run_graph($opts->{id_run}, $opts->{end});
    }else{
      $api_run_caching->run_graph();
    }
    1;
  } or do{
    croak $EVAL_ERROR;
  };

  print "finish process\n";

}
# ----------------------------------------------------------------------
sub initialise {

    my %options = (end=>1, update=>0);

    my $rc = GetOptions(\%options,
                        'id_run:i',
                        'end:i',
                        'update',
                        );
    return \%options;

}
