#!/nfs/team57/ajb/dev/bin/perl -wT
#!/usr/local/bin/perl -wT
#########
# Author:        ajb
# Maintainer:    $Author: ajb $
# Created:       2008-06-18
# Last Modified: $Date: 2008-07-10 13:39:24 +0100 (Thu, 10 Jul 2008) $
# Id:            $Id: submit_swift.pl 2271 2008-07-10 12:39:24Z ajb $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-2.0/scripts/submit_swift.pl $
#

use strict;
use warnings;
use SangerPaths qw(core ensembl tracking badger);
use lib qw(lib /nfs/team57/ajb/development/npg/trunk/lib /nfs/team57/ajb/development/srpipe/trunk/lib );
use npg_qc::api::main;
use npg_qc::api::util;
use LWP::UserAgent;
use Carp;
use English qw{-no_match_vars};
use Perl6::Slurp;

our $VERSION = do { my ($r) = q$LastChangedRevision: 2271 $ =~ /(\d+)/mx; $r; };

$ENV{'PATH'} = join q(:), qw(/bin /usr/bin /usr/local/bin);

main();
0;

sub main {
  print qq{Processing...\n};
  #########
  # overide base uri for npg_qc
  my $uri  = q{http://deskpro19673.dynamic.sanger.ac.uk:8080/cgi-bin/prodsoft/npg_qc/npg_qc/};
  my $util = npg_qc::api::util->new({
    useragent => undef,
    base_uri  => $uri,
    parser    => undef,
  });
  ########
  # create main object
  my $api_main = npg_qc::api::main->new({util => $util});
  my $xml = slurp('t/data/swift/swift_output.xml'); # full path to file
  my $sent_type_counts;
  eval {
    $api_main->websend_any_xml($xml);
    $sent_type_counts = $api_main->process_response_objects();
  };
  if ($EVAL_ERROR) {
    croak $EVAL_ERROR;
  }
  print qq{Successfully websent\n};
  foreach my $sent_type (sort keys%{$sent_type_counts}) {
    print qq{\t$sent_type * $sent_type_counts->{$sent_type_counts}\n};
  }
  print qq{Finished.\n\n};
}
