#########
# Author:        ajb
# Maintainer:    $Author: gq1 $
# Created:       2008-07-21
# Last Modified: $Date: 2008-10-10 09:45:46 +0100 (Fri, 10 Oct 2008) $
# Id:            $Id: 10-model-summary.t 3210 2008-10-10 08:45:46Z gq1 $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-2.0/t/10-model-summary.t $
#

use strict;
use warnings;
use Test::More tests => 9;
use English qw(-no_match_vars);
use SangerPaths qw(core tracking badger ensembl);
use IO::Scalar;
use lib qw{t};
use t::util;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3210 $ =~ /(\d+)/mx; $r; };

use_ok('npg_qc::model::summary');
my $util = t::util->new({fixtures =>1});
{
  my $model = npg_qc::model::summary->new({util => $util});
  isa_ok($model, 'npg_qc::model::summary', '$model');

  my $complete_runs = $model->complete_runs();
  isa_ok($complete_runs, 'ARRAY', '$complete_runs');
  isa_ok($complete_runs->[0], 'HASH', '$complete_runs->[0]');
  is(scalar@{$complete_runs}, 1, '1 complete run end');
  is($complete_runs->[0]->{id_run}, 10, 'id_run is correct');
  is($complete_runs->[0]->{end}, 1, 'end is correct');
  is($complete_runs->[0]->{paired}, 1, 'paired is correct');
  is($model->complete_runs(), $complete_runs, 'cached within object ok');
}
