#########
# Author:        ajb
# Maintainer:    $Author: gq1 $
# Created:       2008-07-23
# Last Modified: $Date: 2008-10-10 09:45:46 +0100 (Fri, 10 Oct 2008) $
# Id:            $Id: 30-api-run_tile.t 3210 2008-10-10 08:45:46Z gq1 $
# $HeadURL: svn+ssh://intcvs1/repos/svn/new-pipeline-dev/npg-qc/tags/release-2.0/t/30-api-run_tile.t $
#

use strict;
use warnings;
use Test::More tests => 14;
use English qw(-no_match_vars);
use IO::Scalar;
use lib qw{t};
use t::api::util;
use npg::api::util;
use t::useragent;

our $VERSION = do { my ($r) = q$LastChangedRevision: 3210 $ =~ /(\d+)/mx; $r; };

use_ok('npg_qc::api::run_tile');
{
  my $ua_mock = {
    q{http://localhost:8080/cgi-bin/prodsoft/npg_qc/npg_qc//run_tile}     => q{t/data/requests/cgi-bin/prodsoft/npg_qc/npg_qc/run_tile.xml},
  };

  my $ua   = t::useragent->new({is_success => 1, mock => $ua_mock});
  my $npg_api_util = npg::api::util->new({useragent => $ua});
  my $util = t::api::util->new({dbh => 'dummy', npg_api_util => $npg_api_util, fixtures => 0, useragent => $ua, parser => 0, base_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg_qc/npg_qc/', npg_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg/npg/'});
  my $run_tile = npg_qc::api::run_tile->new({util => $util});
  isa_ok($run_tile, 'npg_qc::api::run_tile', '$run_tile');
  my @fields = $run_tile->fields();
  is($fields[0], 'id_run_tile', '$run_tile->fields()[0] is id_run_tile');
  my $run_tiles;
  eval { $run_tiles = $run_tile->run_tiles(); };
  is($EVAL_ERROR, q{}, 'no croak on obtaining run_tiles');
  isa_ok($run_tiles, 'ARRAY', '$run_tiles');
  isa_ok($run_tiles->[0], 'npg_qc::api::run_tile', '$run_tiles->[0]');
  is($run_tiles->[9]->id_run_tile(), 10, '$run_tiles->[9]->id_run_tile() is ok');
  is($run_tiles->[9]->id_run(), 1, '$run_tiles->[9]->id_run() is ok');
  is($run_tiles->[9]->position(), 1, '$run_tiles->[9]->position() is ok');
  is($run_tiles->[9]->tile(), 10, '$run_tiles->[9]->tile() is ok');
  is($run_tiles->[9]->end(), 2, '$run_tiles->[9]->end() is ok');
  is($run_tiles->[3]->row(), 2, '$run_tiles->[3]->row() is ok');
  is($run_tiles->[3]->col(), 2, '$run_tiles->[3]->col() is ok');
}
{
  my $ua_mock = {};

  my $ua   = t::useragent->new({is_success => 0, mock => $ua_mock});
  my $npg_api_util = npg::api::util->new({useragent => $ua});
  my $util = t::api::util->new({dbh => 'dummy', npg_api_util => $npg_api_util, fixtures => 0, useragent => $ua, parser => 0, base_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg_qc/npg_qc/', npg_uri => 'http://localhost:8080/cgi-bin/prodsoft/npg/npg/'});
  my $run_tile = npg_qc::api::run_tile->new({util => $util});
  my $run_tiles;
  eval { $run_tiles = $run_tile->run_tiles(); };
  like($EVAL_ERROR, qr{error\ in\ t::useragent}, 'croaked if no success obtaining run_tiles via LWP');
}
1;
